TidyPlatesThreat = LibStub("AceAddon-3.0"):NewAddon("TidyPlatesThreat", "AceConsole-3.0","AceEvent-3.0")
local Media = LibStub("LibSharedMedia-3.0")
local DataBroker = LibStub:GetLibrary("LibDataBroker-1.1",true)
local path = "Interface\\Addons\\TidyPlates_ThreatPlates\\Artwork\\"

--[[Set MultiStyle]]--
if not TidyPlatesThemeList then TidyPlatesThemeList = {} end
TidyPlatesThemeList["ThreatPlates"] = {}

--[[Options and Default Settings]]--
function TidyPlatesThreat:OnInitialize()
	local options = { 
		type = "group", 
		args = {
			OptionsDescription = {
				type = "description",
				order = 1,
				name = "Clear and easy to use nameplate theme for use with TidyPlates.\nFeel free to email me at |cff00ff00Shamtasticle@gmail.com|r\nSyronius, of Black Dragonflight - US <Fallout>",
			},
--[[Options Frames]]--
			OptionsHeader = {
				order = 2,
				type = "header",
				name = "Tidy Plates: Threat Plates v1.7b",
			},
			NameplateOptFrame = {
		        order = 3,
		        type  = "group",
       			name  = "Nameplate Options",
		        args = {
					description = {
						type = "description",
						order = 1,
						name = "Toggle the showing and hiding of nameplates.",
					},
					ShowNeutral = {
						type = "toggle",
						order = 2,
						name = "Show Neutral",
						get = function() return self.db.profile.ShowNeutral end,
						set = function(info,val) 
							self.db.profile.ShowNeutral = not self.db.profile.ShowNeutral
							if self.db.profile.ShowNeutral then return print("-->>Neutral nameplates are now |cff00ff00ON!|r<<--") else return print("-->>Neutral nameplates are now |cffff0000OFF!|r<<--") end
						end
					},
					ShowNormal = {
						type = "toggle",
						order = 3,
						name = "Show Normal",
						get = function() return self.db.profile.ShowNormal end,
						set = function(info,val) 
							self.db.profile.ShowNormal = not self.db.profile.ShowNormal
							if self.db.profile.ShowNormal then return print("-->>Normal nameplates are now |cff00ff00ON!|r<<--") else return print("-->>Normal nameplates are now |cffff0000OFF!|r<<--") end
						end
					},
					ShowElite = {
						type = "toggle",
						order = 4,
						name = "Show Elite",
						get = function() return self.db.profile.ShowElite end,
						set = function(info,val) 
							self.db.profile.ShowElite = not self.db.profile.ShowElite
							if self.db.profile.ShowElite then return print("-->>Nuetral nameplates are now |cff00ff00ON!|r<<--") else return print("-->>Nuetral nameplates are now |cffff0000OFF!|r<<--") end
						end
					},
					ShowBoss = {
						type = "toggle",
						order = 5,
						name = "Show Boss",
						get = function() return self.db.profile.ShowBoss end,
						set = function(info,val) 
							self.db.profile.ShowBoss = not self.db.profile.ShowBoss
							if self.db.profile.ShowBoss then return print("-->>Boss nameplates are now |cff00ff00ON!|r<<--") else return print("-->>Boss nameplates are now |cffff0000OFF!|r<<--") end
						end
					},
					Scale = {
						type = "group",
						order = 6,
						name = "Nameplate Scale",
						desc = "Set nameplate scale levels",
						args = {
							desc = {
								type = "description",
								order = 1,
								name = "Set scale options for normal nameplates.",
							},
							Neutral_scale = {
								type 	= "range",
								order 	= 2,
								name 	= "Neutral Scale",
								get 	= function(info) return self.db.profile.Neutral_scale end,
								set 	= function(info,v)
											self.db.profile.Neutral_scale = v
										end,								
								step = 0.05,
								min = 0.3,
								max = 2,
								isPercent = true,
							},
							Normal_scale = {
								type 	= "range",
								order 	= 3,
								name 	= "Normal Scale",
								get 	= function(info) return self.db.profile.Normal_scale end,
								set 	= function(info,v)
											self.db.profile.Normal_scale = v
										end,								
								step = 0.05,
								min = 0.3,
								max = 2,
								isPercent = true,
							},
							Elite_scale = {
								type 	= "range",
								order 	= 4,
								name 	= "Elite Scale",
								get 	= function(info) return self.db.profile.Elite_scale end,
								set 	= function(info,v)
											self.db.profile.Elite_scale = v
										end,								
								step = 0.05,
								min = 0.3,
								max = 2,
								isPercent = true,
							},
							Boss_scale = {
								type 	= "range",
								order 	= 5,
								name 	= "Boss Scale",
								get 	= function(info) return self.db.profile.Boss_scale end,
								set 	= function(info,v)
											self.db.profile.Boss_scale = v
										end,								
								step = 0.05,
								min = 0.3,
								max = 2,
								isPercent = true,
							},
						},
					},
					Alpha = {
						type = "group",
						order = 7,
						name = "Nameplate Alpha",
						desc = "Set nameplate alpha levels",
						args = {
							desc = {
								type = "description",
								order = 1,
								name = "Set alpha options for normal nameplates.",
							},
							Neutral_alpha = {
								type 	= "range",
								order 	= 2,
								name 	= "Neutral alpha",
								get 	= function(info) return self.db.profile.Neutral_alpha end,
								set 	= function(info,v)
											self.db.profile.Neutral_alpha = v
										end,								
								step = 0.05,
								min = 0.3,
								max = 1,
								isPercent = true,
							},
							Normal_alpha = {
								type 	= "range",
								order 	= 3,
								name 	= "Normal alpha",
								get 	= function(info) return self.db.profile.Normal_alpha end,
								set 	= function(info,v)
											self.db.profile.Normal_alpha = v
										end,								
								step = 0.05,
								min = 0.3,
								max = 1,
								isPercent = true,
							},
							Elite_alpha = {
								type 	= "range",
								order 	= 4,
								name 	= "Elite alpha",
								get 	= function(info) return self.db.profile.Elite_alpha end,
								set 	= function(info,v)
											self.db.profile.Elite_alpha = v
										end,								
								step = 0.05,
								min = 0.3,
								max = 1,
								isPercent = true,
							},
							Boss_alpha = {
								type 	= "range",
								order 	= 5,
								name 	= "Boss alpha",
								get 	= function(info) return self.db.profile.Boss_alpha end,
								set 	= function(info,v)
											self.db.profile.Boss_alpha = v
										end,								
								step = 0.05,
								min = 0.3,
								max = 1,
								isPercent = true,
							},
						},
					},
				},
			},
			TextOptFrame = {
		        order = 4,
		        type  = "group",
       			name  = "Text Options",
		        args = {
					TextOptHeader = {
						order = 1,
						type = "header",
						name = "Text Options",
					},
					hptextdesc = {
						order = 2,
						type = "description",
						name = "\nHP Special Text is the center text displaying the truncated HP amount and HP percentage on nameplates.\n",
					},
					hptext = {
						order = 3,
						type = "toggle",
						name = "Show HP Special Text",
						desc = "Toggles the showing and hiding of HP Special Text",
						get = function() return self.db.profile.hptext end,
						set = function(info,val) 
							self.db.profile.hptext = not self.db.profile.hptext
							if self.db.profile.hptext then return print("-->>HP Special Text is now |cff00ff00ON!|r<<--") else return print("-->>HP Special Text is now |cffff0000OFF!|r<<--") end
						end
					},
					casttext = {
						order = 5,
						type = "toggle",
						name = "Show Spell Cast Text",
						desc = "Toggles the showing and hiding of Spell Cast Text",
						get = function() return self.db.profile.casttext end,
						set = function(info,val) 
							self.db.profile.casttext = not self.db.profile.casttext
							if self.db.profile.casttext then return print("-->>Spell Cast Text is now |cff00ff00ON!|r<<--") else return print("-->>Spell Cast Text is now |cffff0000OFF!|r<<--") end
						end
					},
				},
			},
			ThreatOptFrame = {
		        order = 5,
		        type  = "group",
       			name  = "Threat Options",
		        args = {
					ThreatDescription = {
						type = "description",
						order = 1,
						name = "Toggle the threat system on or off",
					},
					threat = {
						order = 2,
						type = "toggle",
						name = "Enable Threat System",
						desc = "Enable or disable the threat plates system.",
						get = function() return self.db.profile.threat end,
						set = function(info,val) 
							self.db.profile.threat = not self.db.profile.threat
							if self.db.profile.threat then return print("-->>|cff00ff00Threat System is now ON!|r<<--") else return print("-->>|cffff0000Threat System is now OFF!|r<<--") end
						end
					},
					RoleDescription = {
						type = "description",
						order = 3,
						name = "Select which role you're currently fulfilling.",
					},
					DPSRole = {
						order = 4,
						type = "toggle",
						name = "DPS Role",
						desc = "Enable or disable the threat plates system for DPSing.",
						get = function() return not self.db.profile.role end,
						set = function(info,val) 
								self.db.profile.role = false
								self.db.profile.threat = true
								self.db.profile.textrole = "dps"
								print("-->>|cff00ff00DPS Role threat system is now active!!|r<<--")
							end
					},
					TankRole = {
						order = 5,
						type = "toggle",
						name = "Tank Role",
						desc = "Enable or disable the threat plates system for Tanking.",
						get = function() return self.db.profile.role end,
						set = function(info,val) 
								self.db.profile.role = true
								self.db.profile.threat = true
								self.db.profile.textrole = "tank"
								print("-->>|cff00ff00Tank Role threat system is now active!!|r<<--")
							end
					},
					AdditionalToggles = {
						order = 6,
						type = "header",
						name = "Additional Toggles",
					},
					Boss_Threat = {
						order = 10,
						type = "toggle",
						name = "Show Boss Threat",
						desc = "Enable or disable the threat plates system for Boss units.",
						get = function() return self.db.profile.BossThreat end,
						set = function(info,val) 
							self.db.profile.BossThreat = not self.db.profile.BossThreat
							if self.db.profile.BossThreat then return print("-->>|cff00ff00Boss Threat System is now ON!|r<<--") else return print("-->>|cffff0000Boss Threat System is now OFF!|r<<--") end
						end
					},
					Elite_Threat = {
						order = 9,
						type = "toggle",
						name = "Show Elite Threat",
						desc = "Enable or disable the threat plates system for Elite units.",
						get = function() return self.db.profile.EliteThreat end,
						set = function(info,val) 
							self.db.profile.EliteThreat = not self.db.profile.EliteThreat
							if self.db.profile.EliteThreat then return print("-->>|cff00ff00Elite Threat System is now ON!|r<<--") else return print("-->>|cffff0000Elite Threat System is now OFF!|r<<--") end
						end
					},
					Normal_Threat = {
						order = 8,
						type = "toggle",
						name = "Show Normal Threat",
						desc = "Enable or disable the threat plates system for Normal units.",
						get = function() return self.db.profile.NormalThreat end,
						set = function(info,val) 
							self.db.profile.NormalThreat = not self.db.profile.NormalThreat
							if self.db.profile.NormalThreat then return print("-->>|cff00ff00Normal Threat System is now ON!|r<<--") else return print("-->>|cffff0000Normal Threat System is now OFF!|r<<--") end
						end
					},
					Neutral_Threat = {
						order = 7,
						type = "toggle",
						name = "Show Neutral Threat",
						desc = "Enable or disable the threat plates system for Neutral units.",
						get = function() return self.db.profile.NeutralThreat end,
						set = function(info,val) 
							self.db.profile.NeutralThreat = not self.db.profile.NeutralThreat
							if self.db.profile.NeutralThreat then return print("-->>|cff00ff00Neutral Threat System is now ON!|r<<--") else return print("-->>|cffff0000Neutral Threat System is now OFF!|r<<--") end
						end
					},
					DPS = {
						name = "|cffffffffDPS Threat Levels|r",
						type = "group",
						desc = "Set threat scales and alpha for DPSing",
						order = 1,
						args = {
							scaleheader = {
								type = "header",
								order = 1,
								name = "Nameplate Scale",
							},
							lowthreat = {
								type 	= "range",
								order 	= 2,
								name 	= "|cff00ff00Low Threat Scale|r",
								get 	= function(info) return self.db.profile.dpslowscale end,
								set 	= function(info,v)
											self.db.profile.dpslowscale = v
										end,								
								step = 0.05,
								min = 0.3,
								max = 2,
								isPercent = true,
							},
							medthreat = {
								type 	= "range",
								order 	= 3,
								name 	= "|cffffff00Medium Threat Scale|r",
								get 	= function(info) return self.db.profile.dpsmedscale end,
								set 	= function(info,v)
											self.db.profile.dpsmedscale = v
										end,								
								step = 0.05,
								min = 0.3,
								max = 2,
								isPercent = true,
							},
							highthreat = {
								type 	= "range",
								order 	= 4,
								name 	= "|cffff0000High Threat Scale|r",
								get 	= function(info) return self.db.profile.dpshighscale end,
								set 	= function(info,v)
											self.db.profile.dpshighscale = v
										end,								
								step = 0.05,
								min = 0.3,
								max = 2,
								isPercent = true,
							},
							alphaheader = {
								type = "header",
								order = 5,
								name = "Nameplate Alpha",
							},
							alphalow = {
								type 	= "range",
								order 	= 7,
								name 	= "|cff00ff00Low Threat Alpha|r",
								get 	= function(info) return self.db.profile.dps_low_alpha end,
								set 	= function(info,v)
											self.db.profile.dps_low_alpha = v
										end,								
								step = 0.05,
								min = 0.3,
								max = 1,
								isPercent = true,
							},
							alphaMed = {
								type 	= "range",
								order 	= 8,
								name 	= "|cffffff00Medium Threat Alpha|r",
								get 	= function(info) return self.db.profile.dps_medium_alpha end,
								set 	= function(info,v)
											self.db.profile.dps_medium_alpha = v
										end,								
								step = 0.05,
								min = 0.3,
								max = 1,
								isPercent = true,
							},
							alphahigh = {
								type 	= "range",
								order 	= 9,
								name 	= "|cffff0000High Threat Alpha|r",
								get 	= function(info) return self.db.profile.dps_high_alpha end,
								set 	= function(info,v)
											self.db.profile.dps_high_alpha = v
										end,								
								step = 0.05,
								min = 0.3,
								max = 1,
								isPercent = true,
							},
						},
					},
					Tank = {
						name = "|cffffffffTank Threat Levels|r",
						type = "group",
						desc = "Set threat scales and alpha for Tanking",
						order = 2,
						args = {
							tankdesc = {
								type = "header",
								order = 1,
								name = "Nameplate Scale",
							},
							lowthreat = {
								type 	= "range",
								order 	= 2,
								name 	= "|cffff0000Low Threat Scale|r",
								get 	= function(info) return self.db.profile.tanklowscale end,
								set 	= function(info,v)
											self.db.profile.tanklowscale = v
										end,								
								step = 0.05,
								min = 0.3,
								max = 2,
								isPercent = true,
							},
							medthreat = {
								type 	= "range",
								order 	= 3,
								name 	= "|cffffff00Medium Threat Scale|r",
								get 	= function(info) return self.db.profile.tankmedscale end,
								set 	= function(info,v)
											self.db.profile.tankmedscale = v
										end,								
								step = 0.05,
								min = 0.3,
								max = 2,
								isPercent = true,
							},
							highthreat = {
								type 	= "range",
								order 	= 4,
								name 	= "|cff00ff00High Threat Scale|r",
								get 	= function(info) return self.db.profile.tankhighscale end,
								set 	= function(info,v)
											self.db.profile.tankhighscale = v
										end,								
								step = 0.05,
								min = 0.3,
								max = 2,
								isPercent = true,
							},
							alphaheader = {
								type = "header",
								order = 5,
								name = "Nameplate Alpha",
							},
							alphalow = {
								type 	= "range",
								order 	= 7,
								name 	= "|cffff0000Low Threat Alpha|r",
								get 	= function(info) return self.db.profile.tank_low_alpha end,
								set 	= function(info,v)
											self.db.profile.tank_low_alpha = v
										end,								
								step = 0.05,
								min = 0.3,
								max = 1,
								isPercent = true,
							},
							alphaMed = {
								type 	= "range",
								order 	= 8,
								name 	= "|cffffff00Medium Threat Alpha|r",
								get 	= function(info) return self.db.profile.tank_medium_alpha end,
								set 	= function(info,v)
											self.db.profile.tank_medium_alpha = v
										end,								
								step = 0.05,
								min = 0.3,
								max = 1,
								isPercent = true,
							},
							alphahigh = {
								type 	= "range",
								order 	= 9,
								name 	= "|cff00ff00High Threat Alpha|r",
								get 	= function(info) return self.db.profile.tank_high_alpha end,
								set 	= function(info,v)
											self.db.profile.tank_high_alpha = v
										end,								
								step = 0.05,
								min = 0.3,
								max = 1,
								isPercent = true,
							},
						},
					},
				},
			},
		},
	}
	local defaults 	= {
		profile = {
			hptext				= true,
			casttext			= true,
			role 				= true,
			threat 				= true,
			NeutralThreat		= true,
			NormalThreat 		= true,
			EliteThreat			= true,
			BossThreat 			= true,
			ShowNeutral			= true,
			ShowNormal			= true,
			ShowElite			= true,
			ShowBoss			= true,
			textrole 			= "tank",
			Neutral_alpha		= 0.8,
			Normal_alpha		= 0.9,
			Elite_alpha			= 1,
			Boss_alpha 			= 1.1,
			Neutral_scale		= 0.8,
			Normal_scale		= 0.9,
			Elite_scale			= 1,
			Boss_scale 			= 1.1,
			dps_low_alpha		= 1,
			dps_medium_alpha	= 1,
			dps_high_alpha		= 1,
			tank_low_alpha		= 1,
			tank_medium_alpha	= 0.85,
			tank_high_alpha		= 0.75,
			tanklowscale		= 1.25,
			tankmedscale		= 0.90,
			tankhighscale		= 0.70,
			dpshighscale		= 1.25,
			dpsmedscale			= 0.90,
			dpslowscale			= 0.70,
		}
    }
	LibStub("AceConfig-3.0"):RegisterOptionsTable("Tidy Plates: Threat Plates Options:", options)
	self.optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("Tidy Plates: Threat Plates Options:", "Tidy Plates: Threat Plates")
	self:RegisterChatCommand("tptp", function () InterfaceOptionsFrame_OpenToCategory(self.optionsFrame) end)
	self.message = ""
	self.db = LibStub("AceDB-3.0"):New("ThreatPlatesDB", defaults)
end
--[[TPTP Tank Toggle Command]]--
local function TPTPTANK()
	TidyPlatesThreat.db.profile.role = true
	TidyPlatesThreat.db.profile.textrole = "tank"
	print("-->>|cff00ff00Tank Plates Enabled|r<<--")
end
SLASH_TPTPTANK1 = "/tptptank"
SlashCmdList["TPTPTANK"] = TPTPTANK

--[[TPTP DPS Toggle Command]]--
local function TPTPDPS()
	TidyPlatesThreat.db.profile.role = false
	TidyPlatesThreat.db.profile.textrole = "dps"
	print("-->>|cffff0000DPS Plates Enabled|r<<--")
end
SLASH_TPTPDPS1 = "/tptpdps"
SlashCmdList["TPTPDPS"] = TPTPDPS

--[[TPTP Role Toggle Command]]--

local function TPTPTOGGLE()
	TidyPlatesThreat.db.profile.role = not TidyPlatesThreat.db.profile.role
	if TidyPlatesThreat.db.profile.role then 
		TidyPlatesThreat.db.profile.textrole = "tank"
		return print("-->>|cff00ff00Tank Plates Enabled|r<<--")
	else
		TidyPlatesThreat.db.profile.textrole = "dps"
		return print("-->>|cffff0000DPS Plates Enabled|r<<--")
	end
end
SLASH_TPTPTOGGLE1 = "/tptptoggle"
SlashCmdList["TPTPTOGGLE"] = TPTPTOGGLE


function SetSpecialArt(unit)
	if TidyPlatesThreat.db.profile.threat and unit.reaction == "HOSTILE" and InCombatLockdown() then
		return path..TidyPlatesThreat.db.profile.textrole.."\\"..unit.threatSituation
	else
		return nil
	end
end

local Truncate = function(value)
	if value >= 1e6 then
		return format('%.1fm', value / 1e6)
	elseif value >= 1e4 then
		return format('%.1fk', value / 1e3)
	else
		return value
	end
end

function SetSpecialText(unit)
	if TidyPlatesThreat.db.profile.hptext then
		healthpercent = 100* (unit.health / unit.healthmax) 				--[[Creates the health percentage number]]--
		if (unit.health / unit.healthmax) < 1 then 							--[[If Health is less than 100%]]--
			return Truncate(unit.health).." - "..ceil(healthpercent ).."%" 	--[[Display Truncated HP Amount and Percentage]]--
		else 																--[[If HP is 100%]]--
			return --[[ceil(healthpercent ).."%"]]--								--[[Display Nothing or Optional 100% text]]--
		end
	end
end

function SetSpecialText2(unit)
	if TidyPlatesThreat.db.profile.casttext then
		local spellname
		if unit.isCasting then 
			spellname = UnitCastingInfo("target") or UnitChannelInfo("target")
			return spellname
		else return ""
		end
	end
end

local function SetStyle(unit)
	if (InCombatLockdown() and (unit.reaction == "HOSTILE" or unit.reaction == "NEUTRAL") and TidyPlatesThreat.db.profile.threat) then
		if TidyPlatesThreat.db.profile.role then
			if unit.isElite and unit.isDangerous and TidyPlatesThreat.db.profile.BossThreat and TidyPlatesThreat.db.profile.ShowBoss then
				return "tank"
			elseif unit.isElite and not unit.isDangerous and TidyPlatesThreat.db.profile.EliteThreat and TidyPlatesThreat.db.profile.ShowElite then
				return "tank"
			elseif not unit.isElite and not unit.isDangerous and TidyPlatesThreat.db.profile.NormalThreat and TidyPlatesThreat.db.profile.ShowNormal and unit.reaction == "HOSTILE" then
				return "tank"
			elseif TidyPlatesThreat.db.profile.NeutralThreat and unit.reaction == "NEUTRAL" and TidyPlatesThreat.db.profile.ShowNeutral then
				return "tank"
			end
		else
			if unit.isElite and unit.isDangerous and TidyPlatesThreat.db.profile.BossThreat and TidyPlatesThreat.db.profile.ShowBoss then
				return "dps"
			elseif unit.isElite and not unit.isDangerous and TidyPlatesThreat.db.profile.EliteThreat and TidyPlatesThreat.db.profile.ShowElite then
				return "dps"
			elseif not unit.isElite and not unit.isDangerous and TidyPlatesThreat.db.profile.NormalThreat and TidyPlatesThreat.db.profile.ShowNormal and unit.reaction == "HOSTILE" then
				return "dps"
			elseif TidyPlatesThreat.db.profile.NeutralThreat and unit.reaction == "NEUTRAL" and TidyPlatesThreat.db.profile.ShowNeutral then
				return "dps"
			end
		end
	elseif unit.isElite and unit.isDangerous and TidyPlatesThreat.db.profile.ShowBoss then
		return "normal"
	elseif unit.isElite and not unit.isDangerous and TidyPlatesThreat.db.profile.ShowElite then
		return "normal"
	elseif not unit.isElite and not unit.isDangerous and TidyPlatesThreat.db.profile.ShowNormal and unit.reaction ~= "NEUTRAL" then
		return "normal"
	elseif TidyPlatesThreat.db.profile.ShowNeutral and unit.reaction == "NEUTRAL" then
		return "normal"
	else 
		return "empty"
	end
end

local function SetScale(unit)
	if SetStyle(unit) == "tank" then
		if unit.threatSituation == "LOW" then
			return TidyPlatesThreat.db.profile.tanklowscale
		elseif unit.threatSituation == "MEDIUM" then
			return TidyPlatesThreat.db.profile.tankmedscale
		elseif unit.threatSituation == "HIGH" then
			return TidyPlatesThreat.db.profile.tankhighscale
		end
	elseif SetStyle(unit) == "dps" then
		if unit.threatSituation == "LOW" then
			return TidyPlatesThreat.db.profile.dpslowscale
		elseif unit.threatSituation == "MEDIUM" then
			return TidyPlatesThreat.db.profile.dpsmedscale
		elseif unit.threatSituation == "HIGH" then
			return TidyPlatesThreat.db.profile.dpshighscale
		end
	elseif SetStyle(unit) == "normal" then
		if unit.isElite and not unit.isDangerous then
			return TidyPlatesThreat.db.profile.Elite_scale
		elseif unit.isElite and unit.isDangerous then
			return TidyPlatesThreat.db.profile.Boss_scale
		elseif not unit.isElite and not unit.isDangerous and unit.reaction ~= "NEUTRAL" then
			return TidyPlatesThreat.db.profile.Normal_scale
		elseif unit.reaction == "NEUTRAL" then
			return TidyPlatesThreat.db.profile.Neutral_scale
		end
	else 
		return 1
	end
end

local function SetAlpha(unit)
	if SetStyle(unit) == "tank" then
		if unit.threatSituation == "LOW" then
			return TidyPlatesThreat.db.profile.tank_low_alpha
		elseif unit.threatSituation == "MEDIUM" then
			return TidyPlatesThreat.db.profile.tank_medium_alpha
		elseif unit.threatSituation == "HIGH" then
			return TidyPlatesThreat.db.profile.tank_high_alpha
		end
	elseif SetStyle(unit) == "dps" then
		if unit.threatSituation == "LOW" then
			return TidyPlatesThreat.db.profile.dps_low_alpha
		elseif unit.threatSituation == "MEDIUM" then
			return TidyPlatesThreat.db.profile.dps_medium_alpha
		elseif unit.threatSituation == "HIGH" then
			return TidyPlatesThreat.db.profile.dps_high_alpha
		end
	elseif SetStyle(unit) == "normal" then
		if unit.isElite and not unit.isDangerous then
			return TidyPlatesThreat.db.profile.Elite_alpha
		elseif unit.isElite and unit.isDangerous then
			return TidyPlatesThreat.db.profile.Boss_alpha
		elseif not unit.isElite and not unit.isDangerous and unit.reaction ~= "NEUTRAL" then
			return TidyPlatesThreat.db.profile.Normal_alpha
		elseif unit.reaction == "NEUTRAL" then
			return TidyPlatesThreat.db.profile.Neutral_alpha
		end
	else 
		return 1
	end
end
		
TidyPlatesThemeList["ThreatPlates"].SetStyle = SetStyle
TidyPlatesThemeList["ThreatPlates"].SetScale = SetScale
TidyPlatesThemeList["ThreatPlates"].SetAlpha = SetAlpha
TidyPlatesThemeList["ThreatPlates"].SetSpecialText = SetSpecialText
TidyPlatesThemeList["ThreatPlates"].SetSpecialText2 = SetSpecialText2
TidyPlatesThemeList["ThreatPlates"].SetSpecialArt = SetSpecialArt

--[[Auto Settings]]--

SetCVar("threatWarning", 3)
SetCVar("nameplateShowEnemies", 1)
SetCVar("ShowClassColorInNameplate", 1)